﻿Public Class Boss
    'ボス
    Inherits Base1

    Public Shared pattern(4)() As Integer   'ボスの動きの順番を格納してある
    Public Shared sequence As Integer = 0   'pattern()のうち、何番目を実行中かを示す
    Public Shared wait_count As Integer = 0   '待ち時間を数えてくださいます
    Public Shared num_count As Integer = 0    '何個弾を撃ったか数えるよう
    Private Shared dead_count As Integer = 0  '死亡後の良いって来なものを数えるように
    Private Shared deg As Integer = 0         '角度の保存用

    Public Shared Sub appear(ByVal re As Boolean)   'ボスは敵の出現パターンが終了するとでてくる。上から来るぞ！
        If c.boss.exist = False Then
            c.boss.set_c((c.x_max - c.boss_size) \ 2, 0, 800)  '基本的に奥のほうにいらっしゃる
            Dim r As Random = New Random
            c.boss.set_v(1, 0, r.Next(-1, 2))
            If re Then    '残機ありの状態でもっかいボス戦からのときはボスのHPを初期値に戻さない
                c.boss.exist = True
                c.boss.kind = c.stage(0)
                c.boss.size = c.boss_size
                c.boss.action = 0
            Else
                c.boss.set_s(True, c.stage(0), 1000 + (c.stage(0) - 1) * 500, c.boss_size, 0)   'ステージが進むごとに敵のHPが500ずつ増えてく
            End If
        End If
    End Sub

    '出現させる弾の個数、スパンの指定ができます
    Public Shared Sub generate(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer,
                               ByVal vec_x As Single, ByVal vec_y As Integer, ByVal vec_z As Single,
                               ByVal kind As Integer, ByVal size As Integer, ByVal action As Integer,
                               ByVal span As Integer, ByVal num As Integer)
        If wait_count < span Then
            wait_count += 1
        Else
            Dim i As Integer = Bullet.free_check()
            c.bullet(i).set_c(x, y, z)
            c.bullet(i).set_v(vec_x, vec_y, vec_z)
            c.bullet(i).set_s(True, kind, size, action)
            wait_count = 0
            num_count += 1
            If num_count > num Then
                sequence += 1
                wait_count = 0
                num_count = 0
            End If
        End If
    End Sub

    'この先、ボスの生成する弾幕
    Public Shared Sub attack_1() '右なぎ(小玉)
        If c.count Mod 2 = 0 Then
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 180 + deg, 4, c.s_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 180 + deg - 6, 2, c.s_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 180 + deg - 12, 4, c.s_size, 15, 0)
            deg += 5
            If deg >= 180 Then
                deg = 0
                sequence += 1
            End If
        End If
    End Sub
    Public Shared Sub attack_2() '右なぎ(大玉)
        If c.count Mod 2 = 0 Then
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 180 + deg, 4, c.m_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 180 + deg - 6, 2, c.m_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 180 + deg - 12, 4, c.m_size, 15, 0)
            deg += 5
            If deg >= 180 Then
                deg = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_3() '左なぎ(小玉)
        If c.count Mod 2 = 0 Then

            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, deg, 4, c.s_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, deg + 6, 2, c.s_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, deg + 12, 4, c.s_size, 15, 0)
            deg -= 5
            If deg <= -180 Then
                deg = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_4() '左なぎ(大玉)
        If c.count Mod 2 = 0 Then

            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, deg, 4, c.m_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, deg + 6, 2, c.m_size, 15, 0)
            Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, deg + 12, 4, c.m_size, 15, 0)
            deg -= 5
            If deg <= -180 Then
                deg = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_5() '右なぎ厚(小玉)
        If c.count Mod 2 = 0 Then
            deg += 18
            For i As Integer = 0 To 90 Step 3
                Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, i + deg, c.stage(0) + 4, c.s_size, 15, 0)
            Next
            If deg >= 360 Then
                deg = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_6() '左なぎ厚(小玉)
        If c.count Mod 2 = 0 Then
            deg -= 18
            For i As Integer = 180 To 90 Step -3
                Bullet.set_deg(c.boss.x + c.s_size \ 2, c.boss.y + c.s_size \ 2, c.boss.z, i + deg, c.stage(0) + 4, c.s_size, 15, 0)
            Next
            If deg <= -360 Then
                deg = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_7() '円(密度一定になる(薄))
        If c.count Mod 2 = 0 Then
            Bullet.set_circle(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, c.stage(0) + 4, c.s_size, 20, 0, 32, 0)
            wait_count += 1
            If wait_count = 20 Then
                wait_count = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_8() '円(密度一定になる(濃))
        If c.count Mod 2 = 0 Then
            Bullet.set_circle(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, c.stage(0) + 4, c.s_size, 20, 0, 64, 0)
            wait_count += 1
            If wait_count = 20 Then
                wait_count = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_9() '円(密度一定になる(薄, 右回転,消えない))
        If c.count Mod 2 = 0 Then
            For i As Integer = 0 To 17
                Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 20 * i + wait_count, 3, c.s_size, 15, 0)
            Next
            wait_count += 1
            If wait_count = 50 Then
                wait_count = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_10() '円(密度一定になる(濃, 左回転、消える))
        If c.count Mod 2 = 0 Then
            For i As Integer = 0 To 23
                Bullet.set_deg(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 15 * i - wait_count, c.stage(0) + 4, c.s_size, 15, 0)
            Next
            wait_count += 1
            If wait_count = 40 Then
                wait_count = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_11() '円(だんだん密になる)
        If c.count Mod 2 = 0 Then
            If wait_count = 0 Then
                wait_count = 2
            End If
            Bullet.set_circle(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, c.stage(0) + 4, c.s_size, 15, 0, wait_count, 0)

            wait_count += 1
            If wait_count = 32 Then
                wait_count = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_12() '自機狙い(時間をかけて)
        Dim r As Random = New Random
        Bullet.set_to_jiki(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 3, c.s_size, 20, 0)
        Bullet.set_to_jiki(c.boss.x, c.boss.y + c.boss_size \ 2, c.boss.z, 3, c.s_size, 20, 0)
        Bullet.set_to_jiki(c.boss.x + c.boss_size, c.boss.y + c.boss_size \ 2, c.boss.z, 3, c.s_size, 20, 0)
        wait_count += 1
        If wait_count = 30 Then
            wait_count = 0
            sequence += 1
        End If
    End Sub

    Public Shared Sub attack_13() '自機狙い(一気に)
        Dim r As Random = New Random
        For i As Integer = 0 To 50
            Bullet.set_to_jiki(c.boss.x + c.boss_size \ 2 + r.Next(-200, 200), c.boss.y + c.boss_size \ 2, c.boss.z + r.Next(-100, 100), 3, c.s_size, 15, 0)
        Next
        wait_count = 0
        sequence += 1
    End Sub

    Public Shared Sub attack_14() '自機狙い(一気に、かつ円形維持)

        For i As Integer = 0 To 49
            Bullet.ptp(c.boss.x + c.boss_size \ 2 + 100 * Math.Cos(Math.PI * i / 25), c.boss.y + c.boss_size \ 2, c.boss.z + 100 * Math.Sin(Math.PI * i / 25),
                       c.jiki.x + c.jiki.size \ 2 + 100 * Math.Cos(Math.PI * i / 25), c.jiki.z + 100 * Math.Sin(Math.PI * i / 25), 3, c.s_size, 15, 0)
        Next
        wait_count = 0
        sequence += 1
    End Sub

    Public Shared Sub attack_15()  'ランダムばらまき
        Dim r As Random = New Random
        For i As Integer = 0 To 50
            Bullet.ptp(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, r.Next(100, c.x_max - 100), r.Next(0, 300), c.stage(0) + 4, c.s_size, r.Next(5, 30), 0)
        Next
        wait_count = 0
        sequence += 1
    End Sub

    Public Shared Sub attack_16() '直線維持で拡散
        Bullet.set_wide(c.boss.x + c.boss_size \ 2, c.boss.y + c.boss_size \ 2, c.boss.z, 3, c.s_size, 15, 0, 300, 15)
        wait_count = 0
        sequence += 1
    End Sub

    Public Shared Sub attack_17()      '1面のボス用
        Dim r As Random = New Random
        For i As Integer = 0 To 200
            Bullet.appear(r.Next(0, c.x_max - c.m_size), 0, r.Next(0, c.z_max), r.Next(-1, 1), r.Next(5, 10), r.Next(-1, 1), 10, c.m_size, 1)
        Next
        sequence += 1
    End Sub

    Public Shared Sub attack_18()    '2面のボス用
        Dim r As Random = New Random

        For i As Integer = 0 To 2
            Bullet.appear(c.boss.x + c.boss_size \ 2 + 150 * Math.Cos(Math.PI * num_count / 32), 300 + i * 50, c.boss.z + 150 * Math.Sin(Math.PI * num_count / 32), 0, 0, 0, 11, c.m_size, 2)
        Next
        num_count += 1
        If num_count = 64 Then
            num_count = 0
            sequence += 1
        End If

    End Sub

    Public Shared Sub attack_19()    '3面のボス用
        If c.count Mod 3 = 0 Then
            Dim r As Random = New Random
            Bullet.appear(c.jiki.x + c.l_size \ 2, 0, c.jiki.z, 0, 20, 0, 12, c.m_size, 1)
            For i As Integer = 0 To 20
                Bullet.appear(c.jiki.x + c.l_size \ 2 + r.Next(-100, 100), 0, c.jiki.z + r.Next(-100, 100), 0, 20, 0, 12, c.m_size, 1)
            Next

            num_count += 1
            If num_count = 30 Then
                num_count = 0
                sequence += 1
            End If
        End If
    End Sub

    Public Shared Sub attack_20()    '4面のボス用
        Dim r As Random = New Random
        Dim r2 As Integer = r.Next(4, 7)
        If c.count Mod 5 = 0 Then
            Dim theta As Double = r.Next(260, 280) * Math.PI / 180
            Bullet.appear(c.boss.x + c.boss_size \ 2, c.y_max + c.boss_size \ 2, c.boss.z, r2 * Math.Cos(theta), -50, r2 * Math.Sin(theta), 13, c.l_size, 0)
            num_count += 1
        End If

        If num_count = 20 Then
            num_count = 0
            sequence += 1
        End If
    End Sub

    Public Shared Sub attack_21()  '5面のボス用
        Dim r As Random = New Random
        Select Case wait_count
            Case 0
                Bullet.appear(c.jiki.x, 0, c.m_size * (33 - num_count),
                         0, 50, 0,
                         14, c.m_size, 0)
                num_count += 1
                If num_count = 34 Then
                    num_count = 0
                    wait_count += 1
                End If
            Case 1
                Bullet.appear(c.m_size * (19 - num_count), 0, c.jiki.z,
                         0, 50, 0,
                         14, c.m_size, 0)
                num_count += 1
                If num_count = 20 Then
                    num_count = 0
                    wait_count += 1
                End If
            Case 2
                Bullet.appear(c.jiki.x, 0, c.m_size * num_count,
                         0, 50, 0,
                         14, c.m_size, 0)
                num_count += 1
                If num_count = 34 Then
                    num_count = 0
                    wait_count += 1
                End If

            Case 3
                Bullet.appear(c.m_size * num_count, 0, c.jiki.z,
                         0, 50, 0,
                         14, c.m_size, 0)
                num_count += 1
                If num_count = 20 Then
                    num_count = 0
                    wait_count = 0
                    sequence += 1
                End If
        End Select
    End Sub

    Public Shared Sub wait(ByVal time As Integer)
        'time*interval秒間敵を生成せずに待機
        wait_count += 1

        If wait_count = time Then
            sequence += 1
            wait_count = 0
        End If
    End Sub

    Private Shared Sub attack()
        If c.boss.exist Then
            move()
            Select Case pattern(c.stage(0) - 1)(sequence)
                Case -10000 To -1
                    wait(-1 * pattern(c.stage(0) - 1)(sequence))
                Case 0
                    sequence = 0
                Case 1
                    attack_1()
                Case 2
                    attack_2()
                Case 3
                    attack_3()
                Case 4
                    attack_4()
                Case 5
                    attack_5()
                Case 6
                    attack_6()
                Case 7
                    attack_7()
                Case 8
                    attack_8()
                Case 9
                    attack_9()
                Case 10
                    attack_10()
                Case 11
                    attack_11()
                Case 12
                    attack_12()
                Case 13
                    attack_13()
                Case 14
                    attack_14()
                Case 15
                    attack_15()
                Case 16
                    attack_16()
                Case 17
                    attack_17()
                Case 18
                    attack_18()
                Case 19
                    attack_19()
                Case 20
                    attack_20()
                Case 21
                    attack_21()
            End Select
        Else
            If dead_count < 50 Then
                dead_count += 1
            Else
                Functions.clear()
                dead_count = 0
            End If
        End If
    End Sub

    Private Shared Sub move()
        'とりあえずこの範囲で反射しながら動きます
        If c.boss.x < 100 Or c.boss.x > c.x_max - 100 - c.boss.size Then
            c.boss.vec_x *= -1
        End If

        If c.boss.z < 700 Or c.boss.z > c.z_max - 100 Then
            c.boss.vec_z *= -1
        End If

        '速度分だけ動かすぜ～
        c.boss.move_base()

    End Sub


    Public Sub boss_fun()
        attack()
        'danmaku()
        move()
    End Sub
End Class
