﻿
Class Drawing  '描画用関数

    Private Shared z_order(c.teki_num + c.bull_num + c.item_num + c.effect_num + 2) As Integer  '手前にある物から順番にその番号を保存

    Private Shared z_value(c.teki_num + c.bull_num + c.item_num + c.effect_num + 2) As Integer  'いろんなもんのz座標をまとめて突っ込む用
    '自機、ボス、敵、弾、効果、アイテムの順に入れてく

    Public Shared campus As New Bitmap(600, 600)    'window(picturebox)に表示する前にこれに描画してからwindow.imageに代入する

    Private Shared g_d As Graphics = Graphics.FromImage(campus)  '描画に使う

    Private Shared Sub sort()  '並べ替えちゃうぜ！

        For i As Integer = 0 To c.num - 1
            z_order(i) = -1
        Next
        z_value(0) = c.jiki.z
        z_value(1) = c.boss.z


        For i As Integer = 2 To c.teki_num + 1
            z_value(i) = c.teki(i - 2).z
        Next

        For i As Integer = c.teki_num + 2 To c.teki_num + c.bull_num + 1
            z_value(i) = c.bullet(i - (c.teki_num + 2)).z
        Next

        For i As Integer = c.teki_num + c.bull_num + 2 To c.teki_num + c.bull_num + c.effect_num + 1
            z_value(i) = c.effect(i - (c.teki_num + c.bull_num + 2)).z
        Next

        For i As Integer = c.teki_num + c.bull_num + c.effect_num + 2 To c.num - 1
            z_value(i) = c.item(i - (c.teki_num + c.bull_num + c.effect_num + 2)).z
        Next

        '↓自らより奥にあるものの個数を保存
        Dim z_count As Integer

        For i As Integer = 0 To c.num - 1
            For j As Integer = 0 To c.num - 1
                If z_value(i) < z_value(j) Then
                    z_count += 1
                End If
            Next
            Do While z_order(z_count) <> -1
                z_count += 1
            Loop
            z_order(z_count) = i
            z_count = 0
        Next

        '一番奥にあるものから最手前、最手前！ってしていけば、まぁ視覚的におかしくない感じの重なり方になる、はず


    End Sub
    Private Shared Sub draw_back_line_base1(ByVal x1 As Integer, ByVal y1 As Integer,
                                            ByVal x2 As Integer, ByVal y2 As Integer,
                                            ByVal i As Integer, ByVal p As Pen)
        Dim move As Integer = 50 - 5 * (c.count Mod 10)
        'ステージの奥行き(最大1000を20分割するのでこんな感じ)

        'ゲームステージ範囲を示す赤線を入れる

        g_d.DrawLine(p,
                   c.back_drawer.vir_x(x1, (c.z_max * i) \ 20 + move), _
                   c.back_drawer.vir_y(y1, (c.z_max * i) \ 20 + move, 0), _
                   c.back_drawer.vir_x(x2, (c.z_max * i) \ 20 + move), _
                   c.back_drawer.vir_y(y2, (c.z_max * i) \ 20 + move, 0))
    End Sub
    Private Shared Sub draw_back_line_base2(ByVal x1 As Integer, ByVal y1 As Integer, ByVal z1 As Integer,
                                            ByVal x2 As Integer, ByVal y2 As Integer, ByVal z2 As Integer)
        g_d.DrawLine(Pens.Red,
                   c.back_drawer.vir_x(x1, z1),
                   c.back_drawer.vir_y(y1, z1, 0), _
                   c.back_drawer.vir_x(x2, z2),
                   c.back_drawer.vir_y(y2, z2, 0))
    End Sub
    Private Shared Sub draw_back_line()

        For i As Integer = 0 To 19
            'ゲームステージ範囲を示す赤線を入れる

            draw_back_line_base1(0, c.y_max, c.x_max, c.y_max, i, Pens.Navy)

            draw_back_line_base1(0, c.y_max, 0, 0, i, Pens.Red)

            draw_back_line_base1(c.x_max, c.y_max, c.x_max, 0, i, Pens.Red)

        Next
        'これもゲームステージの幅と高さを表す感じの線(ステージという長方形のうちの4辺)
        draw_back_line_base2(0, 0, 0, 0, 0, c.z_max)

        draw_back_line_base2(0, c.y_max, 0, 0, c.y_max, c.z_max)

        draw_back_line_base2(c.x_max, 0, 0, c.x_max, 0, c.z_max)

        draw_back_line_base2(c.x_max, c.y_max, 0, c.x_max, c.y_max, c.z_max)
    End Sub

    'Form1のlabelに入力する関数
    Public Shared Sub label_input(ByVal t1 As String, ByVal t2 As String, ByVal t3 As String, ByVal t4 As String, ByVal t5 As String,
                                 ByVal t6 As String, ByVal t7 As String, ByVal t8 As String, ByVal t9 As String, ByVal t10 As String)
        Form1.Label1.Text = t1
        Form1.Label2.Text = t2
        Form1.Label3.Text = t3
        Form1.Label4.Text = t4
        Form1.Label5.Text = t5
        Form1.Label6.Text = t6
        Form1.Label7.Text = t7
        Form1.Label8.Text = t8
        Form1.Label9.Text = t9
        Form1.Label10.Text = t10
    End Sub

    Public Shared Sub draw(ByRef window As PictureBox)  '描く！
        label_input("LIFE", CStr(c.jiki.HP),
                    "SCORE", CStr(c.score),
                    "TIME(遅いよ)", CStr((c.count * Form1.Timer1.Interval) / 1000),
                    "STAGE", CStr(c.stage(0)),
                    "BOSS<HP>", CStr(c.boss.HP))

        sort()   '並べ替えまっせ
        c.back_drawer.draw(c.back_img(2))
        draw_back_line()

        For i As Integer = 0 To c.num - 1
            Dim j As Integer = z_order(i)
            Dim re_num As Integer = 0

            Select Case j
                Case 0   '自機の描画
                    c.jiki.draw(c.boss_img(0))

                Case 1   'ボスの描画
                    c.boss.draw(c.boss_img(c.boss.kind))

                Case 2 To c.teki_num + 1  '敵の描画
                    re_num = j - 2
                    c.teki(re_num).draw(c.teki_img(c.teki(re_num).kind))
                    
                Case c.teki_num + 2 To c.teki_num + c.bull_num + 1   '弾の描画
                    re_num = j - (c.teki_num + 2)
                    c.bullet(re_num).draw(c.bullet_img(c.bullet(re_num).kind))
                    
                    'エフェクトの描画
                Case c.teki_num + c.bull_num + 2 To c.teki_num + c.bull_num + c.effect_num + 1
                    re_num = j - (c.teki_num + c.bull_num + 2)
                    c.effect(re_num).draw(c.effect_img(c.effect(re_num).HP \ 5))
                    
                    'アイテムの描画
                Case c.teki_num + c.bull_num + c.effect_num + 2 To c.num - 1
                    re_num = j - (c.teki_num + c.bull_num + c.effect_num + 2)
                    c.item(re_num).draw(c.item_img(c.item(re_num).kind))
            End Select


        Next

        window.Image = campus '画面として使うpictureboxに転送

    End Sub

    'スタート画面を描きます
    Public Shared Sub first_draw(ByRef window As PictureBox)
        label_input("い", "ら", "っ", "し", "ゃ", "ぁ", "ぁ", "ぁ", "い", "!!")

        g_d.DrawImage(c.back_img(0), 0, 0, 600, 600)
        window.Image = campus

    End Sub

    'クリア時の画面を描きます
    Public Shared Sub clear_draw(ByRef window As PictureBox)
        If c.stage(0) <= 5 Then
            label_input(CStr(c.stage(0) - 1), "面", "ク", "リ", "ア", "お", "め", "で", "と", "う")
        Else
            label_input("完", "全", "制", "覇", "お", "め", "で", "と", "う", "!!")
        End If

        g_d.DrawImage(c.back_img(3 + c.stage(0)), 0, 0, 600, 600)
        window.Image = campus
        'これが実行される頃にはstage(0)が次のステージの数字になってる
    End Sub

    '死亡時時の画面を描きます
    Public Shared Sub dead_draw(ByRef window As PictureBox)
        label_input("命", "は", "大", "切", "に", "し", "ま", "し", "ょ", "う")

        g_d.DrawImage(c.back_img(1), 0, 0, 600, 600)
        window.Image = campus

    End Sub

    'コンテニュー確認の画面を描きます
    Public Shared Sub continue_draw(ByRef window As PictureBox)
        label_input("続", "け", "る", "??", "や", "め", "ち", "ゃ", "う", "??")

        g_d.DrawImage(c.back_img(3), 0, 0, 600, 600)
        window.Image = campus
    End Sub

    'エンドロールの画像を(動かしつつ)描きます
    Public Shared Sub end_roll_draw(ByRef window As PictureBox)
        label_input("お", "つ", "か", "れ", "さ", "ま", "で", "し", "た", "!!")

        If c.count < 1400 Then
            g_d.DrawImage(c.back_img(4), 0, -1 * c.count, 600, 2000)
            window.Image = campus
        Else
            g_d.DrawImage(c.back_img(4), 0, -1400, 600, 2000)
            window.Image = campus
        End If

    End Sub

End Class


