﻿Public Class Jiki
    '自機クラスでございます
    Inherits Base1

    Private Shared bull_time1 As Integer = 1    '自機の弱弾の発射間隔を決める(フレーム)
    Private Shared bull_time2 As Integer = 1    '自機の強弾の発射間隔を決める(フレーム)
    Private Shared wait_counter As Integer = 0  '死んだ後の余韻とか用の待ち時間カウンタ

    '自機の動作関数
    Private Shared Sub move()
        'キー入力で白い奴を動かしますよ

        '動きだしだけ、加速度的な動き(でないと、ちょこっとだけ動くのができない)

        'x方向の速度
        If c.key_judge(0) Then         '左に行く～

            If c.jiki.vec_x > -15 And c.jiki.vec_x <= 0 Then
                c.jiki.vec_x -= 1
            ElseIf c.jiki.vec_x > 0 Then
                c.jiki.vec_x = 0
            End If
        ElseIf c.key_judge(1) Then      '右に行く～
            If c.jiki.vec_x < 15 And c.jiki.vec_x >= 0 Then
                c.jiki.vec_x += 1
            ElseIf c.jiki.vec_x < 0 Then
                c.jiki.vec_x = 0
            End If
        Else
            c.jiki.vec_x = 0
        End If

        'z方向の速度
        If c.key_judge(2) Then         '奥に行く～
            If c.jiki.vec_z < 15 And c.jiki.vec_z >= 0 Then
                c.jiki.vec_z += 1
            ElseIf c.jiki.vec_z < 0 Then
                c.jiki.vec_z = 0
            End If
        ElseIf c.key_judge(3) Then      '手前に行く～
            If c.jiki.vec_z > -15 And c.jiki.vec_z <= 0 Then
                c.jiki.vec_z -= 1
            ElseIf c.jiki.vec_z > 0 Then
                c.jiki.vec_z = 0
            End If
        Else
            c.jiki.vec_z = 0
        End If

        '速度を座標に反映
        c.jiki.move_base()

    End Sub
    Private Shared Sub border_adjust()
        '自機が外に飛び出さないように、端までいったらそれ以上進まない
        If c.jiki.x < 0 Then
            c.jiki.x = 0
        ElseIf c.jiki.x > c.x_max - c.jiki.size Then
            c.jiki.x = c.x_max - c.jiki.size
        End If

        If c.jiki.y < 0 Then
            c.jiki.y = 0
        ElseIf c.jiki.y > c.y_max - c.jiki.size Then
            c.jiki.y = c.y_max - c.jiki.size
        End If

        If c.jiki.z < 0 Then
            c.jiki.z = 0
        ElseIf c.jiki.z > c.z_max Then
            c.jiki.z = c.z_max
        End If
    End Sub

    Private Shared Sub attack()
        '攻撃！自機の座標に弾を速度設定済みで出現させる
        Bullet.jiki_bull_set(0, c.key_judge(4), bull_time1)  '0弱弾
        Bullet.jiki_bull_set(1, c.key_judge(5), bull_time2)  '1強弾
    End Sub

    Public Shared Sub jiki_fun() '自機クラス内の関数をまとめてやってくれます。
        If c.jiki.exist Then
            move()
            border_adjust()
            attack()
        Else
            If wait_counter < 50 Then
                wait_counter += 1
            Else
                If c.jiki.HP <= 0 Then
                    Functions.dead()
                Else
                    Functions.re_try()
                End If
                wait_counter = 0
            End If
        End If

    End Sub

End Class
