﻿Public Class Teki
    '敵のクラスだよ

    Inherits Base1

    Public Shared pattern(4)() As Integer   '敵の出現パターンを格納してある
    Public Shared wait_count As Integer = 0
    Public Shared num_count As Integer = 0
    Public Shared teki_end_flg As Boolean = False
    Public Shared sequence As Integer = 0


    'ステージに出現してない敵の、配列そ添え字番号を返してくれます
    Public Shared Function free_check() As Integer
        Dim check As Integer = 0  'どの弾もフリーではなかったら、0番さんが犠牲になります

        For i As Integer = 0 To c.teki_num - 1
            If c.teki(i).exist = False Then
                check = i
                Exit For
            End If
        Next

        Return check

    End Function
    '敵を指定スパンでし定数だけだし、その後sequenceを進める
    Public Shared Sub generate(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer,
                               ByVal vec_x As Integer, ByVal vec_y As Integer, ByVal vec_z As Integer,
                               ByVal kind As Integer, ByVal HP As Integer, ByVal size As Integer, ByVal action As Integer,
                               ByVal span As Integer, ByVal num As Integer)
        If wait_count < span Then
            wait_count += 1
        Else
            Dim i As Integer = free_check()
            c.teki(i).set_c(x, y, z)
            c.teki(i).set_v(vec_x, vec_y, vec_z)
            c.teki(i).set_s(True, kind, HP, size, action)
            wait_count = 0
            num_count += 1
            If num_count >= num Then
                sequence += 1
                wait_count = 0
                num_count = 0
            End If
        End If
    End Sub
    
    Public Shared Sub wait(ByVal time As Integer)
        '- time*interval秒間敵を生成せずに待機
        wait_count += 1

        If wait_count = time Then
            sequence += 1
            wait_count = 0
        End If
    End Sub

    '1面の敵の動き
    Public Shared Sub teki_generate1()
        Select Case pattern(c.stage(0) - 1)(sequence)
            Case -10000 To -1
                wait(-1 * pattern(c.stage(0) - 1)(sequence))
            Case 0
                teki_end_flg = True

            Case 1  '左奥から3匹
                generate(0, 300, c.z_max,
                         3, 0, -5,
                         0, 2, c.m_size, 0,
                         8, 3)
            Case 2  '右奥から3匹
                generate(c.x_max - c.m_size, 300, c.z_max,
                         -3, 0, -5,
                         0, 2, c.m_size, 0,
                         8, 3)
            Case 3  '左手前から3匹
                generate(0, 300, 0,
                         3, 0, 5,
                         0, 2, c.m_size, 0,
                         8, 3)
            Case 4   '右手前から3匹
                generate(c.x_max - c.m_size, 300, 0,
                         -3, 0, 5,
                         0, 2, c.m_size, 0,
                         8, 3)
            Case 5   '奥から3匹
                generate(100 + 4 * num_count * c.l_size, 300, c.z_max,
                        0, 0, -5,
                        0, 2, c.m_size, 0,
                        0, 3)
            Case 6   '手前から3匹
                generate(100 + 4 * num_count * c.l_size, 300, 0,
                        0, 0, 5,
                        0, 2, c.m_size, 0,
                        0, 3)
            Case 7   '左から5匹
                generate(0, 300, 100 + 4 * num_count * c.l_size,
                        5, 0, 0,
                        0, 2, c.m_size, 0,
                        0, 5)
            Case 8   '右から5匹
                generate(c.x_max - c.m_size, 300, 100 + 4 * num_count * c.l_size,
                        -5, 0, 0,
                        0, 2, c.m_size, 0,
                        0, 5)
            Case 9  '前後から各3匹
                For k As Integer = 0 To 2
                    Dim i As Integer = free_check()
                    c.teki(i).set_c(100 + 4 * k * c.l_size, 300, c.z_max)
                    c.teki(i).set_v(0, 0, -5)
                    c.teki(i).set_s(True, 0, 2, c.m_size, 0)

                    i = free_check()
                    c.teki(i).set_c(100 + 4 * k * c.l_size, 300, 0)
                    c.teki(i).set_v(0, 0, 5)
                    c.teki(i).set_s(True, 0, 2, c.m_size, 0)
                Next
                sequence += 1

            Case 10  '左右から各5匹
                For k As Integer = 0 To 4
                    Dim i As Integer = free_check()
                    c.teki(i).set_c(0, 300, 100 + 4 * k * c.l_size)
                    c.teki(i).set_v(5, 0, 0)
                    c.teki(i).set_s(True, 0, 2, c.m_size, 0)

                    i = free_check()
                    c.teki(i).set_c(c.x_max - c.m_size, 300, 100 + 4 * k * c.l_size)
                    c.teki(i).set_v(-5, 0, 0)
                    c.teki(i).set_s(True, 0, 2, c.m_size, 0)
                Next
                sequence += 1

        End Select
    End Sub

    Public Shared Sub move1(ByRef teki As Teki)
        'ステージ外に出ると消える
        If teki.x < 0 Or teki.x > c.x_max - teki.size Or _
            teki.z < 0 Or teki.z > c.z_max Then
            teki.disappear()
        End If

        '自機に向かって弾を撃ってくる(敵の数が多くなるとその分撃つ周期が減る)
        If pattern(c.stage(0) - 1)(sequence) >= 9 Then
            If c.count Mod 200 = 0 Then
                Bullet.set_to_jiki(teki.x, teki.y, teki.z, 5, c.s_size, 10, 0)
            End If
        Else
            If c.count Mod 50 = 0 Then
                Bullet.set_to_jiki(teki.x, teki.y, teki.z, 5, c.s_size, 10, 0)
            End If
        End If



    End Sub

    '2面の敵用
    Public Shared Sub teki_generate2()
        Dim s As Integer = c.x_max \ c.l_size
        Dim r As Random = New Random

        Select Case pattern(c.stage(0) - 1)(sequence)
            Case -10000 To -1
                wait(-1 * pattern(c.stage(0) - 1)(sequence))
            Case 0
                teki_end_flg = True
                For i = 0 To c.teki_num - 1
                    c.teki(i).disappear()
                Next
            Case 1    '奥から迫ってくる
                generate(num_count * c.l_size, 0, c.z_max,
                         0, 0, -10,
                         1, 10000, c.l_size, 0,
                         0, s)
                If num_count Mod s = 0 Then
                    Item.appear(r.Next(c.x_max \ c.m_size) * c.m_size, 0, c.z_max - 150, 2, -10, c.m_size)
                    '回避用のジャンプアイテム
                End If

            Case 2       '手前からどどっと
                generate(num_count * c.l_size, 300, 0,
                         0, 0, 10,
                         1, 10000, c.l_size, 0,
                         0, s)
                If num_count Mod s = 0 Then
                    Item.appear(r.Next(c.x_max \ c.m_size) * c.m_size, 200, 150, 2, 10, c.m_size)
                End If
            Case 3    '前後から挟み撃ち
                For i As Integer = 0 To s - 1
                    Dim j As Integer = free_check()
                    c.teki(j).set_c(i * c.l_size, 300, c.z_max)
                    c.teki(j).set_v(0, 0, -6)
                    c.teki(j).set_s(True, 1, 10000, c.l_size, 0)
                    If i Mod s = 0 Then
                        Item.appear(r.Next(c.x_max \ c.m_size) * c.m_size, 300, c.z_max - 150, 2, -6, c.m_size)
                        Item.appear(r.Next(c.x_max \ c.m_size) * c.m_size, 300, c.z_max - 150, 2, -6, c.m_size)
                    End If
                Next
                

                For i As Integer = 0 To s - 1
                    Dim j As Integer = free_check()
                    c.teki(j).set_c(i * c.l_size, 300, 0)
                    c.teki(j).set_v(0, 0, 6)
                    c.teki(j).set_s(True, 1, 10000, c.l_size, 0)
                    If i Mod s = 0 Then
                        Item.appear(r.Next(c.x_max \ c.m_size) * c.m_size, 200, 200, 2, 6, c.m_size)
                        Item.appear(r.Next(c.x_max \ c.m_size) * c.m_size, 200, 200, 2, 6, c.m_size)
                    End If
                Next
                
                sequence += 1
            Case 4     'ランダムに降ってきてそのまま居座る(邪魔)
                generate(r.Next(0, s) * c.l_size, 0, r.Next(0, c.z_max \ c.l_size) * c.l_size,
                         0, 0, 0,
                         1, 10000, c.l_size, 0,
                         2, 2 * s)

        End Select

    End Sub

    Public Shared Sub move2(ByRef teki As Teki)

        If teki.z < 0 Or teki.z > c.z_max Then
            teki.disappear()

        End If

        If sequence <= 5 Then
            'お邪魔キャラであふれてる時は撃たない
            If c.count Mod 100 = 0 And Math.Abs(teki.z - c.jiki.z) > 200 And Math.Abs(teki.x - c.jiki.x) > 200 Then
                Bullet.set_to_jiki(teki.x, teki.y, teki.z, 6, c.s_size, 20, 0)
            End If
        End If
        

    End Sub

    Public Shared Sub teki_generate3()

        Dim r As Random = New Random
        Select Case pattern(c.stage(0) - 1)(sequence)
            Case -10000 To -1
                wait(-1 * pattern(c.stage(0) - 1)(sequence))
            Case 0
                teki_end_flg = True
            Case 1      'ランダムで降った先で弾をばらまく
                generate(r.Next(0, c.x_max \ c.l_size) * c.l_size, 0, r.Next(0, c.z_max \ c.l_size) * c.l_size,
                             0, 0, 0,
                             2, 1, c.l_size, 1,
                             10, 5)
            Case 2    '
                If c.count Mod 20 = 0 Then
                    For i As Integer = 0 To c.teki_num - 1
                        If c.teki(i).action = 2 Then       '最初に出てきたやつを消さないと無限にわいてくる
                            If num_count <> 0 Then
                                Dim j As Integer = free_check()
                                c.teki(j).set_c((c.x_max - c.l_size) \ 2, c.y_max - c.l_size, 600)
                                c.teki(j).set_v(r.Next(5, 10) * Math.Cos(Math.PI * num_count / 16), -35, r.Next(5, 10) * Math.Sin(Math.PI * num_count / 16))
                                c.teki(j).set_s(True, 2, 3, c.l_size, 3)
                                num_count += 1
                                Exit For
                            End If
                        End If
                        'actionが2のやつが出てない時
                        If i = c.teki_num - 1 Then
                            If num_count = 0 Then
                                num_count = 1
                                Dim j As Integer = free_check()
                                c.teki(j).set_c((c.x_max - c.l_size) \ 2, 0, 600)
                                c.teki(j).set_v(0, 0, 0)
                                c.teki(j).set_s(True, 2, 100, c.l_size, 2)
                            Else
                                wait_count = 0
                                num_count = 0
                                sequence += 1
                            End If
                        End If
                    Next
                End If
            Case 3        'ランダムに落ちてくる(一定時間たつと死ななくなる(邪魔))
                generate(r.Next(2, c.x_max \ c.l_size) * c.l_size, 0, r.Next(2, c.z_max \ c.l_size) * c.l_size,
                            0, 0, 0,
                            2, 5, c.l_size, 4,
                            0, 20)
        End Select

    End Sub

    Public Shared Sub move3(ByRef teki As Teki)

        Static judge As Integer = 1
        Dim r As Random = New Random

        If c.count Mod 100 = 0 Then
            '定期的にランダム方向に打つ
            Bullet.set_deg(teki.x, teki.y, teki.z, r.Next(0, 360), 7, c.s_size, 10, 0)
        End If

        Select Case teki.action
            Case 1   '地面に着き、バウンドした瞬間消えて、弾をばらまく
                If teki.vec_y < 0 Then
                    Bullet.set_circle(teki.x + teki.size \ 2, teki.y + teki.size \ 2, teki.z,
                                          7, c.s_size, 10, 0, 8, 0)
                    teki.disappear()
                End If
            Case 3
                If c.count Mod 10 = 0 Then  '出てきたやつが外に出ないように(保険)
                    If teki.x < 0 Then
                        teki.x = 0
                        teki.vec_x = 0
                    ElseIf teki.x > c.x_max - teki.size Then
                        teki.x = c.x_max - teki.size
                        teki.vec_x = 0
                    End If
                    If teki.z < 0 Then
                        teki.z = 0
                        teki.vec_z = 0
                    ElseIf teki.z > c.z_max Then
                        teki.z = c.z_max
                        teki.vec_z = 0
                    End If

                    If teki.vec_x > 0 Then  '基本的に出ないようにするために減速
                        teki.vec_x -= 1
                    ElseIf teki.vec_x < 0 Then
                        teki.vec_x += 1
                    End If
                    If teki.vec_z > 0 Then
                        teki.vec_z -= 1
                    ElseIf teki.vec_z < 0 Then
                        teki.vec_z += 1
                    End If
                End If
            Case 4
                If wait_count < 500 And judge <> c.count Then
                    wait_count += 1
                    judge += 1
                ElseIf wait_count >= 300 Then
                    teki.HP = 10000      '時間がたってもまだ生きてたら、HP10000に
                End If
                judge = c.count


        End Select

    End Sub

    '4面
    Public Shared Sub teki_generate4()
        Dim r As Random = New Random

        Select Case pattern(c.stage(0) - 1)(sequence)
            Case -10000 To -1
                wait(-1 * pattern(c.stage(0) - 1)(sequence))
            Case 0
                teki_end_flg = True
            Case 1   '1~4は四隅から直進してくる感じ（初期位置と進行方向がそれぞれ違う）
                Dim j As Integer = free_check()
                c.teki(j).set_c(0, c.y_max - c.l_size, c.z_max - 200)
                c.teki(j).set_v(7, 0, 0)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size - 200, c.y_max - c.l_size, c.z_max)
                c.teki(j).set_v(0, 0, -7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(200, c.y_max - c.l_size, 0)
                c.teki(j).set_v(0, 0, 7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 2)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size, c.y_max - c.l_size, 200)
                c.teki(j).set_v(-7, 0, 0)
                c.teki(j).set_s(True, 3, 10, c.l_size, 2)

                sequence += 1

            Case 2
                Dim j As Integer = free_check()
                c.teki(j).set_c(0, c.y_max - c.l_size, c.z_max)
                c.teki(j).set_v(7, 0, -7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size, c.y_max - c.l_size, c.z_max)
                c.teki(j).set_v(-7, 0, -7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(0, c.y_max - c.l_size, 0)
                c.teki(j).set_v(7, 0, 7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 2)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size, c.y_max - c.l_size, 0)
                c.teki(j).set_v(-7, 0, 7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 2)

                sequence += 1

            Case 3
                Dim j As Integer = free_check()
                c.teki(j).set_c(200, c.y_max - c.l_size, c.z_max)
                c.teki(j).set_v(0, 0, -7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size, c.y_max - c.l_size, c.z_max - 200)
                c.teki(j).set_v(-7, 0, 0)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(0, c.y_max - c.l_size, 200)
                c.teki(j).set_v(7, 0, 0)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size - 200, c.y_max - c.l_size, 0)
                c.teki(j).set_v(0, 0, 7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                sequence += 1

            Case 4
                Dim j As Integer = free_check()
                c.teki(j).set_c(0, c.y_max - c.l_size, c.z_max)
                c.teki(j).set_v(7, 0, -7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size, c.y_max - c.l_size, c.z_max)
                c.teki(j).set_v(-7, 0, -7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(0, c.y_max - c.l_size, 0)
                c.teki(j).set_v(7, 0, 7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                j = free_check()
                c.teki(j).set_c(c.x_max - c.l_size, c.y_max - c.l_size, 0)
                c.teki(j).set_v(-7, 0, 7)
                c.teki(j).set_s(True, 3, 10, c.l_size, 0)

                sequence += 1

            Case 5  'ランダムに1匹落とす、これを中心に放射状に敵が出てくる
                generate(r.Next(0, c.x_max - c.l_size), 0, r.Next(0, c.z_max),
                            0, 0, 0,
                            3, 5, c.l_size, 1,
                            0, 1)
            Case 6

        End Select
        
    End Sub
    Public Shared Sub move4(ByRef teki As Teki)
        Dim r As Random = New Random

        If c.count Mod 20 = 0 Then
            Bullet.set_deg(teki.x, teki.y, teki.z, r.Next(0, 360), 8, c.s_size, 10, 0)
        End If

        If teki.x < 0 Or teki.x > c.x_max - teki.size Or _
            teki.z < 0 Or teki.z > c.z_max Then
            teki.exist = False
        End If

        If teki.action = 1 Then
            If teki.vec_y < 0 Then
                'actionが1の敵の落下点から十六方に敵が出てくる
                For i As Integer = 0 To 15
                    Dim j As Integer = free_check()
                    c.teki(j).set_c(teki.x, teki.y, teki.z)
                    c.teki(j).set_v(7 * Math.Cos(Math.PI * i / 8), 0, 7 * Math.Sin(Math.PI * i / 8))
                    c.teki(j).set_s(True, 3, 10, c.l_size, 0)
                Next
                teki.disappear()
            End If
        End If


    End Sub

    Public Shared Sub teki_generate5()
        Dim r As Random = New Random

        Select Case pattern(c.stage(0) - 1)(sequence)
            Case -10000 To -1
                wait(-1 * pattern(c.stage(0) - 1)(sequence))
            Case 0
                teki_end_flg = True
            Case 1    'ランダムに落下、その後自機を付け回す
                generate(r.Next(c.x_max \ c.l_size) * c.l_size, 300, r.Next(c.z_max \ c.l_size) * c.l_size,
                         0, 0, 0,
                         4, 5, c.l_size, 1,
                         10, 5)
            Case 2     '怒涛の羊、前から
                generate(r.Next(c.x_max \ c.l_size) * c.l_size, c.y_max - c.l_size, c.z_max,
                         0, 0, -20,
                         4, 5, c.l_size, 0,
                         0, 20 + r.Next(0, 4) * 5)
            Case 3      '後ろから
                generate(r.Next(c.x_max \ c.l_size) * c.l_size, c.y_max - c.l_size, 0,
                         0, 0, 20,
                         4, 5, c.l_size, 0,
                         0, 15 + r.Next(0, 4) * 3)
            Case 4      '左から
                generate(0, c.y_max - c.l_size, r.Next(c.z_max \ c.l_size) * c.l_size,
                         20, 0, 0,
                         4, 5, c.l_size, 0,
                         0, 15 + r.Next(0, 4) * 3)
            Case 5       '右から
                generate(c.x_max - c.l_size, c.y_max - c.l_size, r.Next(c.z_max \ c.l_size) * c.l_size,
                         -20, 0, 0,
                         4, 5, c.l_size, 0,
                         0, 15 + r.Next(0, 4) * 3)
        End Select

    End Sub
    Public Shared Sub move5(ByRef teki As Teki)

        '画面外に出たら消える
        If teki.x < 0 Or teki.x > c.x_max - teki.size Or _
            teki.z < 0 Or teki.z > c.z_max Then
            teki.exist = False
        End If

        '自機を追いかけまわす
        If teki.action = 1 Then
            If teki.x + teki.size < c.jiki.x And teki.vec_x <= 6 Then
                teki.vec_x += 2
            ElseIf teki.x - teki.size > c.jiki.x And teki.vec_x >= -6 Then
                teki.vec_x -= 2
            End If

            If teki.z + teki.size < c.jiki.z And teki.vec_z <= 6 Then
                teki.vec_z += 2
            ElseIf teki.z - teki.size > c.jiki.z And teki.vec_z >= -6 Then
                teki.vec_z -= 2
            End If
        End If

        If c.count Mod 200 = 0 Then
            Bullet.appear(teki.x, teki.y, teki.z, teki.vec_x, teki.vec_y, teki.vec_z, 9, c.s_size, 0)
        End If

    End Sub

    Public Shared Sub teki_generate()

        Select Case c.stage(0)
            Case 1
                teki_generate1()
            Case 2
                teki_generate2()
            Case 3
                teki_generate3()
            Case 4
                teki_generate4()
            Case 5
                teki_generate5()
        End Select

        If teki_end_flg Then
            Boss.appear(False)
            c.stage(1) = 1
        End If

    End Sub

    Public Shared Sub move()
        For i As Integer = 0 To c.teki_num - 1
            If c.teki(i).exist Then

                Select Case c.stage(0)
                    Case 1
                        move1(c.teki(i))
                    Case 2
                        move2(c.teki(i))
                    Case 3
                        move3(c.teki(i))
                    Case 4
                        move4(c.teki(i))
                    Case 5
                        move5(c.teki(i))
                End Select
                c.teki(i).move_base()
            End If

        Next

    End Sub

    Public Shared Sub teki_fun()
        teki_generate()
        move()
    End Sub
End Class
